#!/bin/bash

export PATH=${HOME}/usr/bin:$PATH
export LD_LIBRARY_PATH=${HOME}/usr/lib:$LD_LIBRARY_PATH

BUILD_DIR="build_$(uname -n)"

if [ -d $BUILD_DIR ]
then
    	echo "Remove existing directory $BUILD_DIR"
        rm -fr $BUILD_DIR
fi

mkdir -p $BUILD_DIR
cd $BUILD_DIR

# export NVCPP=/opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/bin/nvc++
# export CC=/opt/rh/devtoolset-11/root/usr/bin/x86_64-redhat-linux-gcc
# export CXX=/opt/rh/devtoolset-11/root/usr/bin/x86_64-redhat-linux-g++

# {Si vous avez des problèmes de compilation allez voir \href{https://forums.developer.nvidia.com/t/nvc-error-namespace-std-has-no-member-align-val-t/146761}{le forum NVidia}.

cmake .. -DCMAKE_CXX_COMPILER=$NVCPP -DCMAKE_C_COMPILER=$CC -DGPU_MODE=yes -DUSE_TBB=no -DMUST_JOB=yes -DSELF_TESTS_MODE=no -DCMAKE_INSTALL_PREFIX=${HOME}/usr
make

NB_IMAGE_SAVED=5
NB_INTER_IMAGE=680000
NB_TEST_PER_PROGRAM=1

>&2 echo "======== Gray Scott GPU nvc++ ========"
for i in `seq 1 ${NB_TEST_PER_PROGRAM}`
do
	echo "Gray Scott GPU nvc $i"
	time ./program/gray_scott_gpu_nvcpp_vector -n ${NB_IMAGE_SAVED} -r 1080 -c 1920 -e ${NB_INTER_IMAGE}
done


