# Petite phase de débugage

Il faut d'abord lancer un job en interactif (sur une machine GPU) :

```
condor_submit -interactive tmp_job_config/submit_a100.condor
```

Ensuite, il faut initialiser la variable `CUDA_VISIBLE_DEVICE` :

```
export CUDA_VISIBLE_DEVICE=${_CONDOR_Assignedgpus}
```

Et enfin, on peut débugger.

Le problème persiste, même si le vector d'options a la bonne taille :
```
Warning: set address range perms: large range [0x24000000, 0x3bfff000) (noaccess)
==10746== Warning: set address range perms: large range [0x59eaf000, 0x87eae000) (noaccess)
==10746== Warning: set address range perms: large range [0x5a000000, 0x85828000) (defined)
OptionParser::addOption : p_currentMode = 0, p_vecMode.size() = 1
==10746== Invalid free() / delete / delete[] / realloc()
==10746==    at 0x4C2B51D: operator delete(void*) (vg_replace_malloc.c:586)
==10746==    by 0x5059D7D: OptionValue::~OptionValue() (OptionValue.cpp:683)
==10746==    by 0x5050F55: Option::~Option() (Option.cpp:70)
==10746==    by 0x40E3C9: void OptionParser::addOption<float>(std::string const&, std::string const&, float, std::string const&) (OptionParser_impl.h:28)
==10746==    by 0x40DA32: createOptionParser() (main.cpp:40)
==10746==    by 0x40E0D8: main (main.cpp:155)
==10746==  Address 0x5a000080 is in a rw- mapped file /dev/nvidia-uvm segment
==10746== 
==10746== Invalid free() / delete / delete[] / realloc()
==10746==    at 0x4C2B51D: operator delete(void*) (vg_replace_malloc.c:586)
==10746==    by 0x5059D7D: OptionValue::~OptionValue() (OptionValue.cpp:683)
==10746==    by 0x40E3D5: void OptionParser::addOption<float>(std::string const&, std::string const&, float, std::string const&) (OptionParser_impl.h:28)
==10746==    by 0x40DA32: createOptionParser() (main.cpp:40)
==10746==    by 0x40E0D8: main (main.cpp:155)
==10746==  Address 0x5a000100 is in a rw- mapped file /dev/nvidia-uvm segment
==10746== 
	--killrate=FLOAT , -k FLOAT : rate of the process which converts V into P
		Default value : 0.054
		This argument is optional
==10746== Invalid free() / delete / delete[] / realloc()
==10746==    at 0x4C2B51D: operator delete(void*) (vg_replace_malloc.c:586)
==10746==    by 0x5059D7D: OptionValue::~OptionValue() (OptionValue.cpp:683)
==10746==    by 0x5050F55: Option::~Option() (Option.cpp:70)
==10746==    by 0x5053577: OptionMode::~OptionMode() (OptionMode.cpp:680)
==10746==    by 0x5054E27: OptionParser::~OptionParser() (OptionParser.cpp:680)
==10746==    by 0x40E16B: main (main.cpp:183)
==10746==  Address 0x5a000000 is in a rw- mapped file /dev/nvidia-uvm segment
==10746== 
==10746== 
==10746== HEAP SUMMARY:
==10746==     in use at exit: 10,268,689 bytes in 8,760 blocks
==10746==   total heap usage: 15,817 allocs, 7,060 frees, 92,211,430 bytes allocated
==10746== 
==10746== LEAK SUMMARY:
==10746==    definitely lost: 0 bytes in 0 blocks
==10746==    indirectly lost: 0 bytes in 0 blocks
==10746==      possibly lost: 23,056 bytes in 193 blocks
==10746==    still reachable: 10,245,633 bytes in 8,567 blocks
==10746==         suppressed: 0 bytes in 0 blocks
==10746== Rerun with --leak-check=full to see details of leaked memory
==10746== 
==10746== For lists of detected and suppressed errors, rerun with: -s
==10746== ERROR SUMMARY: 3 errors from 3 contexts (suppressed: 0 from 0)
```



`̀``
ldd ./program/gray_scott_gpu_nvcpp_vector
	linux-vdso.so.1 =>  (0x00007ffe3e14c000)
	libgray_scott_data_format.so => /mustfs/LAPP-DATA/cta/paubert/TestCondor/COURS/GrayScottGpuNvcppVector/build_interactive/DataFormat/libgray_scott_data_format.so (0x00002af89fdb8000)
	liboption_parser.so.1 => /mustfs/LAPP-DATA/cta/paubert/TestCondor/COURS/usr/lib/liboption_parser.so.1 (0x00002af89ffc0000)
	libstring_utils.so.1 => /mustfs/LAPP-DATA/cta/paubert/TestCondor/COURS/usr/lib/libstring_utils.so.1 (0x00002af8a01ed000)
	libhdf5_cpp.so.8 => /lib64/libhdf5_cpp.so.8 (0x00002af8a0400000)
	libhdf5.so.8 => /lib64/libhdf5.so.8 (0x00002af8a0655000)
	libacchost.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libacchost.so (0x00002af8a0afb000)
	libaccdevaux.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libaccdevaux.so (0x00002af8a0d6b000)
	libacccuda.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libacccuda.so (0x00002af8a0f77000)
	libnvhpcman.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libnvhpcman.so (0x00002af8a12a9000)
	libcudart.so.11.0 => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/cuda/11.4/lib64/libcudart.so.11.0 (0x00002af8a14ae000)
	libdl.so.2 => /lib64/libdl.so.2 (0x00002af8a1750000)
	libcudadevice.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libcudadevice.so (0x00002af8a1954000)
	libcudanvhpc.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libcudanvhpc.so (0x00002af8a1b67000)
	libnvhpcatm.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libnvhpcatm.so (0x00002af8a1d6b000)
	libstdc++.so.6 => /lib64/libstdc++.so.6 (0x00002af8a1f76000)
	libnvomp.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libnvomp.so (0x00002af8a227e000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00002af8a2ef8000)
	libnvcpumath.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libnvcpumath.so (0x00002af8a3114000)
	libnvc.so => /opt/nvidia/hpc_sdk/Linux_x86_64/21.9/compilers/lib/libnvc.so (0x00002af8a3549000)
	librt.so.1 => /lib64/librt.so.1 (0x00002af8a37a1000)
	libm.so.6 => /lib64/libm.so.6 (0x00002af8a39a9000)
	libc.so.6 => /lib64/libc.so.6 (0x00002af8a3cab000)
	libgcc_s.so.1 => /lib64/libgcc_s.so.1 (0x00002af8a4079000)
	libsz.so.2 => /lib64/libsz.so.2 (0x00002af8a428f000)
	libz.so.1 => /lib64/libz.so.1 (0x00002af8a4492000)
	/lib64/ld-linux-x86-64.so.2 (0x00002af89fb94000)
	libaec.so.0 => /lib64/libaec.so.0 (0x00002af8a46a8000)
``̀


